diff --git a/web/pgadmin/utils/driver/psycopg2/connection.py b/web/pgadmin/utils/driver/psycopg3/connection.py
similarity index 82%
rename from web/pgadmin/utils/driver/psycopg2/connection.py
rename to web/pgadmin/utils/driver/psycopg3/connection.py
index 450573d02..e7551f922 100644
--- a/web/pgadmin/utils/driver/psycopg2/connection.py
+++ b/web/pgadmin/utils/driver/psycopg3/connection.py
@@ -9,30 +9,29 @@
 
 """
 Implementation of Connection.
-It is a wrapper around the actual psycopg2 driver, and connection
+It is a wrapper around the actual psycopg3 driver, and connection
 object.
 """
 
-import secrets
-import select
+import random
 import datetime
+import asyncio
 from collections import deque
-import psycopg2
+import psycopg
 from flask import g, current_app
 from flask_babel import gettext
 from flask_security import current_user
-from pgadmin.utils.crypto import decrypt
-from psycopg2.extensions import encodings
+from pgadmin.utils.crypto import decrypt, encrypt
+from psycopg._encodings import py_codecs as encodings
 
 import config
 from pgadmin.model import User
 from pgadmin.utils.exception import ConnectionLost, CryptKeyMissing
 from pgadmin.utils import get_complete_file_path
 from ..abstract import BaseConnection
-from .cursor import DictCursor
-from .typecast import numeric_typecasters, register_global_typecasters,\
+from .cursor import DictCursor, AsyncDictCursor
+from .typecast import register_global_typecasters,\
     register_string_typecasters, register_binary_typecasters, \
-    unregister_numeric_typecasters, \
     register_array_to_string_typecasters, ALL_JSON_TYPES
 from .encoding import get_encoding, configure_driver_encodings
 from pgadmin.utils import csv
@@ -40,6 +39,7 @@ from pgadmin.utils.master_password import get_crypt_key
 from io import StringIO
 from pgadmin.utils.locker import ConnectionLocker
 
+
 _ = gettext
 
 # Register global type caster which will be applicable to all connections.
@@ -51,13 +51,13 @@ class Connection(BaseConnection):
     """
     class Connection(object)
 
-        A wrapper class, which wraps the psycopg2 connection object, and
+        A wrapper class, which wraps the psycopg3 connection object, and
         delegate the execution to the actual connection object, when required.
 
     Methods:
     -------
     * connect(**kwargs)
-      - Connect the PostgreSQL/EDB Postgres Advanced Server using the psycopg2
+      - Connect the PostgreSQL/EDB Postgres Advanced Server using the psycopg3
       driver
 
     * execute_scalar(query, params, formatted_exception_msg)
@@ -91,7 +91,7 @@ class Connection(BaseConnection):
       - Ping the server.
 
     * _release()
-      - Release the connection object of psycopg2
+      - Release the connection object of psycopg3
 
     * _reconnect()
       - Attempt to reconnect to the database
@@ -125,7 +125,7 @@ class Connection(BaseConnection):
         server.
 
     * _formatted_exception_msg(exception_obj, formatted_msg)
-      - This method is used to parse the psycopg2.Error object and returns the
+      - This method is used to parse the psycopg.Error object and returns the
         formatted error message if flag is set to true else return
         normal error message.
 
@@ -314,36 +314,68 @@ class Connection(BaseConnection):
                 config.APP_NAME, conn_id)
 
             with ConnectionLocker(manager.kerberos_conn):
-                pg_conn = psycopg2.connect(
-                    host=manager.local_bind_host if manager.use_ssh_tunnel
-                    else manager.host,
-                    hostaddr=manager.local_bind_host if manager.use_ssh_tunnel
-                    else manager.hostaddr,
-                    port=manager.local_bind_port if manager.use_ssh_tunnel
-                    else manager.port,
-                    database=database,
-                    user=user,
-                    password=password,
-                    async_=self.async_,
-                    passfile=get_complete_file_path(passfile),
-                    sslmode=manager.ssl_mode,
-                    sslcert=get_complete_file_path(manager.sslcert),
-                    sslkey=get_complete_file_path(manager.sslkey),
-                    sslrootcert=get_complete_file_path(manager.sslrootcert),
-                    sslcrl=get_complete_file_path(manager.sslcrl),
-                    sslcompression=True if manager.sslcompression else False,
-                    service=manager.service,
-                    connect_timeout=manager.connect_timeout
-                )
-
-                # If connection is asynchronous then we will have to wait
-                # until the connection is ready to use.
-                if self.async_ == 1:
-                    self._wait(pg_conn)
+                if self.async_:
+                    autocommit = True
+                    if 'auto_commit' in kwargs:
+                        autocommit = kwargs['auto_commit']
+
+                    async def connectdbserver():
+                        return await psycopg.AsyncConnection.connect(
+                            host=manager.local_bind_host if
+                            manager.use_ssh_tunnel
+                            else manager.host,
+                            hostaddr=manager.local_bind_host if
+                            manager.use_ssh_tunnel
+                            else manager.hostaddr,
+                            port=manager.local_bind_port if
+                            manager.use_ssh_tunnel
+                            else manager.port,
+                            dbname=database,
+                            user=user,
+                            password=password,
+                            passfile=get_complete_file_path(passfile),
+                            sslmode=manager.ssl_mode,
+                            sslcert=get_complete_file_path(manager.sslcert),
+                            sslkey=get_complete_file_path(manager.sslkey),
+                            sslrootcert=get_complete_file_path(
+                                manager.sslrootcert),
+                            sslcrl=get_complete_file_path(manager.sslcrl),
+                            sslcompression=True if manager.sslcompression else
+                            False,
+                            service=manager.service,
+                            connect_timeout=manager.connect_timeout,
+                            cursor_factory=AsyncDictCursor,
+                            autocommit=autocommit)
+                    pg_conn = asyncio.run(connectdbserver())
+                else:
+                    pg_conn = psycopg.Connection.connect(
+                        host=manager.local_bind_host if manager.use_ssh_tunnel
+                        else manager.host,
+                        hostaddr=manager.local_bind_host if
+                        manager.use_ssh_tunnel
+                        else manager.hostaddr,
+                        port=manager.local_bind_port if manager.use_ssh_tunnel
+                        else manager.port,
+                        dbname=database,
+                        user=user,
+                        password=password,
+                        passfile=get_complete_file_path(passfile),
+                        sslmode=manager.ssl_mode,
+                        sslcert=get_complete_file_path(manager.sslcert),
+                        sslkey=get_complete_file_path(manager.sslkey),
+                        sslrootcert=get_complete_file_path(
+                            manager.sslrootcert),
+                        sslcrl=get_complete_file_path(manager.sslcrl),
+                        sslcompression=True if manager.sslcompression else
+                        False,
+                        service=manager.service,
+                        connect_timeout=manager.connect_timeout,
+                        cursor_factory=DictCursor
+                    )
 
-        except psycopg2.Error as e:
+        except psycopg.Error as e:
             manager.stop_ssh_tunnel()
-            if e.pgerror:
+            if hasattr(e, 'pgerror'):
                 msg = e.pgerror
             elif e.diag.message_detail:
                 msg = e.diag.message_detail
@@ -363,6 +395,8 @@ class Connection(BaseConnection):
         # Overwrite connection notice attr to support
         # more than 50 notices at a time
         pg_conn.notices = deque([], self.ASYNC_NOTICE_MAXLENGTH)
+        pg_conn.add_notify_handler(self.check_notifies)
+        pg_conn.add_notice_handler(self.get_notices)
 
         self.conn = pg_conn
         self.wasConnected = True
@@ -440,20 +474,22 @@ class Connection(BaseConnection):
         formatted_exception_msg = self._formatted_exception_msg
         try:
             self.__internal_blocking_execute(cur, query, params)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             return formatted_exception_msg(pe, False)
         return None
 
     def _initialize(self, conn_id, **kwargs):
         self.execution_aborted = False
-        self.__backend_pid = self.conn.get_backend_pid()
+        self.__backend_pid = self.conn.info.backend_pid
 
         setattr(g, self.ARGS_STR.format(
             self.manager.sid,
             self.conn_id.encode('utf-8')
         ), None)
 
+        register_string_typecasters(self.conn)
+
         status, cur = self.__cursor()
 
         manager = self.manager
@@ -462,18 +498,20 @@ class Connection(BaseConnection):
         # By default asynchronous connection runs in autocommit mode.
         self._set_auto_commit(kwargs)
 
-        register_string_typecasters(self.conn)
-
         if self.array_to_string:
+            print("ARRAY to string")
             register_array_to_string_typecasters(self.conn)
 
         # Register type casters for binary data only after registering array to
         # string type casters.
         if self.use_binary_placeholder:
             register_binary_typecasters(self.conn)
-
+        #
         postgres_encoding, self.python_encoding, typecast_encoding = \
-            get_encoding(self.conn.encoding)
+            get_encoding(self.conn.info.encoding)
+        print("HERE==", self.conn.info.encoding)
+        # print("init")
+        # print(postgres_encoding)
 
         # Note that we use 'UPDATE pg_settings' for setting bytea_output as a
         # convenience hack for those running on old, unsupported versions of
@@ -518,7 +556,7 @@ class Connection(BaseConnection):
         if cur.rowcount > 0:
             row = cur.fetchmany(1)[0]
             manager.ver = row['version']
-            manager.sversion = self.conn.server_version
+            manager.sversion = self.conn.info.server_version
 
         status = self._execute(cur, """
 SELECT
@@ -547,7 +585,7 @@ WHERE db.datname = current_database()""")
         FROM
             pg_catalog.pg_stat_gssapi
         WHERE pid = pg_backend_pid()""")
-                    if status is None and cur.rowcount > 0:
+                    if status is None and cur.get_rowcount() > 0:
                         res_enc = cur.fetchmany(1)[0]
                         manager.db_info[res['did']]['gss_authenticated'] =\
                             res_enc['gss_authenticated']
@@ -598,7 +636,7 @@ WHERE db.datname = current_database()""")
 
         if status is None and 'user' not in kwargs:
             manager.user_info = dict()
-            if cur.rowcount > 0:
+            if cur.get_rowcount() > 0:
                 manager.user_info = cur.fetchmany(1)[0]
 
     def _set_server_type_and_password(self, kwargs, manager):
@@ -626,7 +664,7 @@ WHERE db.datname = current_database()""")
                 manager.server_cls = st
                 break
 
-    def __cursor(self, server_cursor=False):
+    def __cursor(self, server_cursor=False, scrollable=False):
 
         if not get_crypt_key()[0]:
             raise CryptKeyMissing()
@@ -676,14 +714,14 @@ WHERE db.datname = current_database()""")
                 # Providing name to cursor will create server side cursor.
                 cursor_name = "CURSOR:{0}".format(self.conn_id)
                 cur = self.conn.cursor(
-                    name=cursor_name, cursor_factory=DictCursor
+                    name=cursor_name
                 )
             else:
-                cur = self.conn.cursor(cursor_factory=DictCursor)
-        except psycopg2.Error as pe:
+                cur = self.conn.cursor(scrollable=scrollable)
+        except psycopg.Error as pe:
             current_app.logger.exception(pe)
             errmsg = gettext(
-                "Failed to create cursor for psycopg2 connection with error "
+                "Failed to create cursor for psycopg3 connection with error "
                 "message for the server#{1}:{2}:\n{0}"
             ).format(
                 str(pe), self.manager.sid, self.db
@@ -733,7 +771,7 @@ WHERE db.datname = current_database()""")
 
         try:
             cur.scroll(position, mode='absolute')
-        except psycopg2.Error:
+        except psycopg.Error:
             # bypassing the error as cursor tried to scroll on the
             # specified position, but end of records found
             current_app.logger.log(
@@ -746,9 +784,10 @@ WHERE db.datname = current_database()""")
         # it is encoded with python ascii
         # unicode_escape helps in escaping and unescaping
         if self.conn and \
-            self.conn.encoding in ('SQL_ASCII', 'SQLASCII',
-                                   'MULE_INTERNAL', 'MULEINTERNAL')\
-                and params is not None and isinstance(params, dict):
+            self.conn.info.encoding in ('SQL_ASCII', 'SQLASCII',
+                                        'MULE_INTERNAL', 'MULEINTERNAL'
+                                        ) and params is not None\
+                and isinstance(params, dict):
             for key, val in params.items():
                 modified_val = val
                 # "unicode_escape" will convert single backslash to double
@@ -780,8 +819,6 @@ WHERE db.datname = current_database()""")
 
         params = self.escape_params_sqlascii(params)
         cur.execute(query, params)
-        if self.async_ == 1:
-            self._wait(cur.connection)
 
     def execute_on_server_as_csv(self, params=None,
                                  formatted_exception_msg=False, records=2000):
@@ -799,7 +836,7 @@ WHERE db.datname = current_database()""")
         if not cur:
             return False, self.CURSOR_NOT_FOUND
 
-        if self.conn.isexecuting():
+        if self.conn.pgconn.connect_poll() != 3:
             return False, gettext(
                 "Asynchronous query execution/operation underway."
             )
@@ -812,16 +849,15 @@ WHERE db.datname = current_database()""")
         except Exception:
             current_app.logger.warning('Error encoding query')
 
-        dsn = self.conn.get_dsn_parameters()
         current_app.logger.log(
             25,
             "Execute (with server cursor) by {pga_user} on "
             "{db_user}@{db_host}/{db_name} #{server_id} -  "
             "{conn_id} (Query-id: {query_id}):\n{query}".format(
                 pga_user=current_user.email,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query,
@@ -829,11 +865,9 @@ WHERE db.datname = current_database()""")
             )
         )
         try:
-            # Unregistering type casting for large size data types.
-            unregister_numeric_typecasters(self.conn)
             if self.async_ == 1:
                 self._wait(cur.connection)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             errmsg = self._formatted_exception_msg(pe, formatted_exception_msg)
             current_app.logger.error(
@@ -887,9 +921,6 @@ WHERE db.datname = current_database()""")
                 yield gettext('The query executed did not return any data.')
                 return
 
-            # Type cast the numeric values
-            results = numeric_typecasters(results, conn_obj)
-
             header = []
             json_columns = []
 
@@ -949,10 +980,12 @@ WHERE db.datname = current_database()""")
                 # bypass error, if cannot scroll back
                 rows_fetched_from = trans_obj.get_fetched_row_cnt()
                 cur.scroll(rows_fetched_from, mode='absolute')
-            except psycopg2.Error:
+            except psycopg.Error:
                 # bypassing the error as cursor tried to scroll on the
                 # specified position, but end of records found
                 pass
+            except Exception:
+                pass
 
         # Registering back type caster for large size data types to string
         # which was unregistered at starting
@@ -966,18 +999,17 @@ WHERE db.datname = current_database()""")
 
         if not status:
             return False, str(cur)
-        query_id = secrets.choice(range(1, 9999999))
+        query_id = random.randint(1, 9999999)
 
-        dsn = self.conn.get_dsn_parameters()
         current_app.logger.log(
             25,
             "Execute (scalar) by {pga_user} on "
             "{db_user}@{db_host}/{db_name} #{server_id} - "
             "{conn_id} (Query-id: {query_id}):\n{query}".format(
                 pga_user=current_user.email,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query,
@@ -986,7 +1018,7 @@ WHERE db.datname = current_database()""")
         )
         try:
             self.__internal_blocking_execute(cur, query, params)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             if not self.connected():
                 if self.auto_reconnect and not self.reconnecting:
@@ -1011,9 +1043,11 @@ WHERE db.datname = current_database()""")
                 )
             )
             return False, errmsg
+        except Exception:
+            print("EXCEPTION.....")
 
-        self.row_count = cur.rowcount
-        if cur.rowcount > 0:
+        self.row_count = cur.get_rowcount()
+        if cur.get_rowcount() > 0:
             res = cur.fetchone()
             if len(res) > 0:
                 return True, res[0]
@@ -1036,26 +1070,28 @@ WHERE db.datname = current_database()""")
         params = self.escape_params_sqlascii(params)
 
         self.__async_cursor = None
-        status, cur = self.__cursor()
+        status, cur = self.__cursor(scrollable=True)
 
         if not status:
             return False, str(cur)
-        query_id = secrets.choice(range(1, 9999999))
+        query_id = random.randint(1, 9999999)
 
         encoding = self.python_encoding
 
         query = query.encode(encoding)
 
-        dsn = self.conn.get_dsn_parameters()
+        self.__async_cursor = cur
+        self.__async_query_id = query_id
+
         current_app.logger.log(
             25,
             "Execute (async) by {pga_user} on {db_user}@{db_host}/{db_name} "
             "#{server_id} - {conn_id} (Query-id: "
             "{query_id}):\n{query}".format(
                 pga_user=current_user.username,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query.decode(encoding),
@@ -1068,8 +1104,7 @@ WHERE db.datname = current_database()""")
             self.__notifies = []
             self.execution_aborted = False
             cur.execute(query, params)
-            res = self._wait_timeout(cur.connection)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             errmsg = self._formatted_exception_msg(pe, formatted_exception_msg)
             current_app.logger.error(
                 "Failed to execute query (execute_async) for the server "
@@ -1082,9 +1117,6 @@ WHERE db.datname = current_database()""")
                 )
             )
 
-            # Check for the asynchronous notifies.
-            self.check_notifies()
-
             if self.is_disconnected(pe):
                 raise ConnectionLost(
                     self.manager.sid,
@@ -1093,10 +1125,7 @@ WHERE db.datname = current_database()""")
                 )
             return False, errmsg
 
-        self.__async_cursor = cur
-        self.__async_query_id = query_id
-
-        return True, res
+        return True, None
 
     def execute_void(self, query, params=None, formatted_exception_msg=False):
         """
@@ -1112,18 +1141,17 @@ WHERE db.datname = current_database()""")
 
         if not status:
             return False, str(cur)
-        query_id = secrets.choice(range(1, 9999999))
+        query_id = random.randint(1, 9999999)
 
-        dsn = self.conn.get_dsn_parameters()
         current_app.logger.log(
             25,
             "Execute (void) by {pga_user} on "
             "{db_user}@{db_host}/{db_name} #{server_id} - "
             "{conn_id} (Query-id: {query_id}):\n{query}".format(
                 pga_user=current_user.email,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query,
@@ -1133,7 +1161,7 @@ WHERE db.datname = current_database()""")
 
         try:
             self.__internal_blocking_execute(cur, query, params)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             if not self.connected():
                 if self.auto_reconnect and not self.reconnecting:
@@ -1200,17 +1228,16 @@ WHERE db.datname = current_database()""")
         if not status:
             return False, str(cur)
 
-        query_id = secrets.choice(range(1, 9999999))
-        dsn = self.conn.get_dsn_parameters()
+        query_id = random.randint(1, 9999999)
         current_app.logger.log(
             25,
             "Execute (2darray) by {pga_user} on "
             "{db_user}@{db_host}/{db_name} #{server_id} - "
             "{conn_id} (Query-id: {query_id}):\n{query}".format(
                 pga_user=current_user.email,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query,
@@ -1219,7 +1246,7 @@ WHERE db.datname = current_database()""")
         )
         try:
             self.__internal_blocking_execute(cur, query, params)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             if not self.connected() and self.auto_reconnect and \
                     not self.reconnecting:
@@ -1246,10 +1273,9 @@ WHERE db.datname = current_database()""")
         ] or []
 
         rows = []
-        self.row_count = cur.rowcount
-        if cur.rowcount > 0:
-            for row in cur:
-                rows.append(row)
+        self.row_count = cur.get_rowcount()
+        if cur.get_rowcount() > 0:
+            rows = cur.fetchall()
 
         return True, {'columns': columns, 'rows': rows}
 
@@ -1259,17 +1285,16 @@ WHERE db.datname = current_database()""")
 
         if not status:
             return False, str(cur)
-        query_id = secrets.choice(range(1, 9999999))
-        dsn = self.conn.get_dsn_parameters()
+        query_id = random.randint(1, 9999999)
         current_app.logger.log(
             25,
             "Execute (dict) by {pga_user} on "
             "{db_user}@{db_host}/{db_name} #{server_id} - "
             "{conn_id} (Query-id: {query_id}):\n{query}".format(
                 pga_user=current_user.email,
-                db_user=dsn['user'],
-                db_host=dsn['host'],
-                db_name=dsn['dbname'],
+                db_user=self.conn.info.user,
+                db_host=self.conn.info.host,
+                db_name=self.conn.info.dbname,
                 server_id=self.manager.sid,
                 conn_id=self.conn_id,
                 query=query,
@@ -1278,7 +1303,7 @@ WHERE db.datname = current_database()""")
         )
         try:
             self.__internal_blocking_execute(cur, query, params)
-        except psycopg2.Error as pe:
+        except psycopg.Error as pe:
             cur.close()
             if not self.connected():
                 if self.auto_reconnect and not self.reconnecting:
@@ -1310,10 +1335,10 @@ WHERE db.datname = current_database()""")
         ] or []
 
         rows = []
-        self.row_count = cur.rowcount
-        if cur.rowcount > 0:
-            for row in cur:
-                rows.append(dict(row))
+        self.row_count = cur.get_rowcount()
+
+        if cur.get_rowcount() > 0:
+            rows = cur.fetchall()
 
         return True, {'columns': columns, 'rows': rows}
 
@@ -1334,7 +1359,7 @@ WHERE db.datname = current_database()""")
         if not cur:
             return False, self.CURSOR_NOT_FOUND
 
-        if self.conn.isexecuting():
+        if self.conn.pgconn.is_busy():
             return False, gettext(
                 "Asynchronous query execution/operation underway."
             )
@@ -1356,7 +1381,7 @@ WHERE db.datname = current_database()""")
                     for col in self.column_info:
                         new_row.append(row[col['name']])
                     result.append(new_row)
-            except psycopg2.ProgrammingError:
+            except psycopg.ProgrammingError:
                 result = None
         else:
             # User performed operation which dose not produce record/s as
@@ -1406,14 +1431,14 @@ WHERE db.datname = current_database()""")
 
         try:
             with ConnectionLocker(manager.kerberos_conn):
-                pg_conn = psycopg2.connect(
+                pg_conn = psycopg.connect(
                     host=manager.local_bind_host if manager.use_ssh_tunnel
                     else manager.host,
                     hostaddr=manager.local_bind_host if manager.use_ssh_tunnel
                     else manager.hostaddr,
                     port=manager.local_bind_port if manager.use_ssh_tunnel
                     else manager.port,
-                    database=self.db,
+                    dbname=self.db,
                     user=manager.user,
                     password=password,
                     passfile=get_complete_file_path(manager.passfile),
@@ -1424,13 +1449,14 @@ WHERE db.datname = current_database()""")
                     sslcrl=get_complete_file_path(manager.sslcrl),
                     sslcompression=True if manager.sslcompression else False,
                     service=manager.service,
-                    connect_timeout=manager.connect_timeout
+                    connect_timeout=manager.connect_timeout,
+                    cursor_factory=DictCursor
                 )
 
-        except psycopg2.Error as e:
-            if e.pgerror:
+        except psycopg.Error as e:
+            if hasattr(e, 'pgerror'):
                 msg = e.pgerror
-            elif e.message:
+            elif hasattr(e, 'message'):
                 msg = e.message
             elif e.diag.message_detail:
                 msg = e.diag.message_detail
@@ -1448,13 +1474,13 @@ Failed to reset the connection to the server due to following error:
 
         pg_conn.notices = deque([], self.ASYNC_NOTICE_MAXLENGTH)
         self.conn = pg_conn
-        self.__backend_pid = pg_conn.get_backend_pid()
+        self.__backend_pid = pg_conn.info.backend_pid
 
         return True, None
 
     def transaction_status(self):
         if self.conn:
-            return self.conn.get_transaction_status()
+            return self.conn.info.transaction_status
         return None
 
     def ping(self):
